﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using FATX_Browser.FATX;

namespace FATX_Browser
{
    public partial class EntryAction : Form
    {
        // Declare our thread that will extract shit
        System.Threading.Thread Worker;
        // Our max value
        int MaxValue = 0;
        // Our progress update value
        int Progress = 0;
        // Our string to draw
        string CurrentEntry = "";
        // Are we extracting deleted entries?
        bool ExtractDeleted = false;
        // Our timer that will serve to update the frontend
        static Timer FrontEnd = new Timer();
        // Our timer's thread
        System.Threading.Thread TimerThread = new System.Threading.Thread(new System.Threading.ThreadStart(FrontEnd.Start));
        // The text to apply to our form
        string FormText = "Extracting -- ";

        public EntryAction(File[] FilesToExtract, string OutPath)
        {
            InitializeComponent();
            // Set our timer's tick event
            FrontEnd.Tick += new EventHandler(FrontEnd_Tick);
            // Set our form closing event
            this.FormClosing += new FormClosingEventHandler(EntryAction_FormClosing);

            // Create our thread start for the worker thread
            System.Threading.ThreadStart ts = delegate { BeginExtract((Entry[])FilesToExtract, OutPath); };
            // Start the worker thread
            Worker = new System.Threading.Thread(ts);
            Worker.Start();
            // Start our timer thread
            FrontEnd.Enabled = true;
            TimerThread.Start();
        }

        public EntryAction(Folder[] FoldersToExtract, string OutPath, bool ExtractDeletedEntries)
        {
            InitializeComponent();
            // Set our timer's tick event
            FrontEnd.Tick += new EventHandler(FrontEnd_Tick);
            // Set our form closing event
            this.FormClosing += new FormClosingEventHandler(EntryAction_FormClosing);

            // Set whether or not we're extracting deleted entries
            ExtractDeleted = ExtractDeletedEntries;
            // Create our thread start for the worker thread
            System.Threading.ThreadStart ts = delegate { BeginExtract((Entry[])FoldersToExtract, OutPath); };
            // Start the worker thread
            Worker = new System.Threading.Thread(ts);
            Worker.Start();
            // Start our timer thread
            FrontEnd.Enabled = true;
            TimerThread.Start();
        }

        public EntryAction(Entry[] EntriesToExtract, string OutPath, bool ExtractDeletedEntries)
        {
            InitializeComponent();
            // Set our timer's tick event
            FrontEnd.Tick += new EventHandler(FrontEnd_Tick);
            // Set our form closing event
            this.FormClosing += new FormClosingEventHandler(EntryAction_FormClosing);

            //Set whether or not we're extracting deleted entries...
            ExtractDeleted = ExtractDeletedEntries;
            // Create our thread start for the worker thread
            System.Threading.ThreadStart ts = delegate { BeginExtract((Entry[])EntriesToExtract, OutPath); };
            // Start the worker thread
            Worker = new System.Threading.Thread(ts);
            Worker.Start();
            // Start our timer thread
            FrontEnd.Enabled = true;
            TimerThread.Start();
        }

        public EntryAction(File f, string OutPath)
        {
            InitializeComponent();
            // Set our timer's tick event
            FrontEnd.Tick += new EventHandler(FrontEnd_Tick);
            // Set our form closing event
            this.FormClosing += new FormClosingEventHandler(EntryAction_FormClosing);


            // Create our threadstart
            System.Threading.ThreadStart ts = delegate { BeginExtract(f, OutPath); };
            // Start the worker thread
            Worker = new System.Threading.Thread(ts);
            Worker.Start();
            // Start our timer thread
            FrontEnd.Enabled = true;
            TimerThread.Start();
        }

        public EntryAction(Folder f, string OutPath, bool ExtractDeletedEntries)
        {
            InitializeComponent();
            // Set our timer's tick event
            FrontEnd.Tick += new EventHandler(FrontEnd_Tick);
            // Set our form closing event
            this.FormClosing += new FormClosingEventHandler(EntryAction_FormClosing);

            //Set whether or not we're extracting deleted entries...
            ExtractDeleted = ExtractDeletedEntries;
            // Create our threadstart
            System.Threading.ThreadStart ts = delegate { BeginExtract(f, OutPath); };
            // Start the worker thread
            Worker = new System.Threading.Thread(ts);
            Worker.Start();
            // Start our timer thread
            FrontEnd.Enabled = true;
            TimerThread.Start();
        }

        public EntryAction(string InPath, Folder root)
        {
            InitializeComponent();
            // Set our timer's tick event
            FrontEnd.Tick += new EventHandler(FrontEnd_Tick);
            // Set our form closing event
            this.FormClosing += new FormClosingEventHandler(EntryAction_FormClosing);


            FormText = "Injecting -- ";
            // Create our threadstart
            System.Threading.ThreadStart ts = delegate { BeginInject(InPath, root); };
            // Start the worker thread
            Worker = new System.Threading.Thread(ts);
            Worker.Start();
            // Start our timer thread
            FrontEnd.Enabled = true;
            TimerThread.Start();
        }

        public EntryAction(string[] InPaths, Folder root)
        {
            InitializeComponent();
            // Set our timer's tick event
            FrontEnd.Tick += new EventHandler(FrontEnd_Tick);
            // Set our form closing event
            this.FormClosing += new FormClosingEventHandler(EntryAction_FormClosing);


            FormText = "Injecting -- ";
            // Create our threadstart
            System.Threading.ThreadStart ts = delegate { BeginInject(InPaths, root); };
            // Start the worker thread
            Worker = new System.Threading.Thread(ts);
            Worker.Start();
            // Start our timer thread
            FrontEnd.Enabled = true;
            TimerThread.Start();
        }

        void FrontEnd_Tick(object sender, EventArgs e)
        {
            if (Handle == null)
            {
                return;
            }
            try
            {
                // Set the maximium
                progressBar1.Invoke(new ProgressBarValue_Callback(ProgressBarMax), new object[] { (int)MaxValue, });
                // Set the current value
                progressBar1.Invoke(new ProgressBarValue_Callback(ProgressBarValue), new object[] { (int)Progress });
                // Update the text of our label
                label1.Invoke(new LabelText_Callback(LabelText), new object[] { CurrentEntry });
                // Update the text of our form
                this.Invoke(new LabelText_Callback(UpdateFormText), new object[] { CurrentEntry });
            }
            catch { }
        }

        void EntryAction_FormClosing(object sender, FormClosingEventArgs e)
        {
            try
            {
                // Try to abort the threads
                Worker.Abort();
            }
            catch { }
            try
            {
                // Try to abort the timer
                AbortTimer();
            }
            catch { }
        }

        #region Stuff for invoking
        private delegate void ProgressBarValue_Callback(int Value);
        private delegate void LabelText_Callback(string text);
        private delegate void call_FormClose();
        void ProgressBarValue(int value)
        {
            progressBar1.Value = value;
        }

        void ProgressBarMax(int value)
        {
            progressBar1.Maximum = value;
        }

        void LabelText(string text)
        {
            label1.Text = text;
        }

        void UpdateFormText(string text)
        {
            this.Text = FormText + text;
        }
        #endregion

        void BeginExtract(Entry e, string Path)
        {
            // If we're working with a folder...
            if (e.IsFolder)
            {
                Folder f = (Folder)e;
                f.ExtractRecursive(Path, ref CurrentEntry, ref Progress, ref MaxValue, true, ExtractDeleted);
            }
            else
            {
                File f = (File)e;
                CurrentEntry = f.Name;
                f.Extract(Path, ref Progress, ref MaxValue);
            }
            System.Media.SystemSounds.Asterisk.Play();
            this.Invoke(new call_FormClose(this.Close));
        }

        void BeginExtract(Entry[] Entries, string Path)
        {
            // Loop for each entry in our array
            foreach (Entry e in Entries)
            {
                // If we're working with a folder...
                if (e.IsFolder)
                {
                    Folder f = (Folder)e;
                    f.ExtractRecursive(Path, ref CurrentEntry, ref Progress, ref MaxValue, true, ExtractDeleted);
                }
                else
                {
                    File f = (File)e;
                    CurrentEntry = f.Name;
                    f.Extract(Path + "\\" + f.Name, ref Progress, ref MaxValue);
                }
            }

            // We made it through!  yay.
            System.Media.SystemSounds.Asterisk.Play();
            this.Invoke(new call_FormClose(this.Close));
        }

        void BeginInject(string[] Paths, Folder root)
        {
            // Loop for each path
            foreach (string s in Paths)
            {
                // If the path is a folder
                if (new Misc().IsFolder(s))
                {
                    // Call to the inject folder function in the root
                    try
                    {
                        root.InjectFolder(s, ref CurrentEntry, ref Progress, ref MaxValue);
                    }
                    catch (Exception e)
                    {
                        if (e.Message.Contains("name"))
                        {
                            if (MessageBox.Show(e.Message + "\r\nWould you like to overwrite it?", "Folder Already Exists", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == System.Windows.Forms.DialogResult.Yes)
                            {
                                // Loop for each folder in "root" until we find the matching folder
                                foreach (Folder f in root.SubFolders(false))
                                {
                                    // Found the folder, let's do this.
                                    if (f.Name == new System.IO.FileInfo(s).Name)
                                    {
                                        f.OverWriteFolder(s, ref CurrentEntry, ref Progress, ref MaxValue);
                                    }
                                }
                            }
                        }
                    }
                }
                else
                {
                    CurrentEntry = new System.IO.FileInfo(s).Name;
                    try
                    {
                        root.InjectFile(s, ref Progress, ref MaxValue);

                    }
                    catch (Exception e)
                    {
                        if (e.Message.Contains("name"))
                        {
                            if (MessageBox.Show(e.Message + "\r\nWould you like to overwrite it?", "File Already Exists", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == System.Windows.Forms.DialogResult.Yes)
                            {
                                // Loop for each folder in "root" until we find the matching folder
                                foreach (File f in root.Files(false))
                                {
                                    // Found the folder, let's do this.
                                    if (f.Name == new System.IO.FileInfo(s).Name)
                                    {
                                        f.OverWrite(s, ref Progress, ref MaxValue);
                                    }
                                }
                            }
                        }
                    }
                }
            }
            System.Media.SystemSounds.Asterisk.Play();
            this.Invoke(new call_FormClose(this.Close));
        }

        void BeginInject(string Path, Folder root)
        {
            // If the path is a folder...
            if (new Misc().IsFolder(Path))
            {
                // Call to the inject folder function in the root
                try
                {
                    root.InjectFolder(Path, ref CurrentEntry, ref Progress, ref MaxValue);
                }
                catch (Exception e)
                {
                    if (e.Message.Contains("name"))
                    {
                        if (MessageBox.Show(e.Message + "\r\nWould you like to overwrite it?", "Folder Already Exists", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == System.Windows.Forms.DialogResult.Yes)
                        {
                            // Loop for each folder in "root" until we find the matching folder
                            foreach (Folder f in root.SubFolders(false))
                            {
                                // Found the folder, let's do this.
                                if (f.Name == new System.IO.FileInfo(Path).Name)
                                {
                                    f.OverWriteFolder(Path, ref CurrentEntry, ref Progress, ref MaxValue);
                                }
                            }
                        }
                    }
                }
            }
            else
            {
                CurrentEntry = new System.IO.FileInfo(Path).Name;
                try
                {
                    root.InjectFile(Path, ref Progress, ref MaxValue);

                }
                catch (Exception e)
                {
                    if (e.Message.Contains("name"))
                    {
                        if (MessageBox.Show(e.Message + "\r\nWould you like to overwrite it?", "File Already Exists", MessageBoxButtons.YesNo, MessageBoxIcon.Question) == System.Windows.Forms.DialogResult.Yes)
                        {
                            // Loop for each folder in "root" until we find the matching folder
                            foreach (File f in root.Files(false))
                            {
                                // Found the folder, let's do this.
                                if (f.Name == new System.IO.FileInfo(Path).Name)
                                {
                                    f.OverWrite(Path, ref Progress, ref MaxValue);
                                }
                            }
                        }
                    }
                }
            }
            System.Media.SystemSounds.Asterisk.Play();
            this.Invoke(new call_FormClose(this.Close));
        }

        void AbortTimer()
        {
            FrontEnd.Stop();
            FrontEnd.Enabled = false;
            TimerThread.Abort();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
