﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using FATX_Browser.FATX;

namespace FATX_Browser
{
    public partial class PropertiesForm : Form
    {
        File xFile;
        public PropertiesForm(File f)
        {
            InitializeComponent();
            xFile = f;
            this.Text = "Properties -- " + f.Name;
            if (!f.IsSTFSPackage)
            {
                //The package isn't an stfs package -- disable that shit
                groupBox4.Enabled = false;
            }
            else
            {
                LoadSTFS();
            }
            LoadGeneral();
        }

        private void LoadGeneral()
        {
            string ftype;
            if (xFile.Name.EndsWith(".xbe"))
            {
                ftype = "Xbox Executable";
            }
            else if (xFile.Name.EndsWith(".xex"))
            {
                ftype = "Xenon Executable";
            }
            else if (xFile.IsSTFSPackage)
            {
                ftype = "STFS Package";
            }
            else
            {
                ftype = "File";
            }
            fileType.Text = ftype;
            size.Text = xFile.Size.ToString();
            sizeOnDisk.Text = new Misc().UpToNearestCluster(xFile.Size, xFile.PartInfo.ClusterSize).ToString();
            Created.Text = xFile.CreationDate.ToString();
            Modified.Text = xFile.ModifiedDate.ToString();
            Accessed.Text = xFile.AccessedDate.ToString();
        }

        private void LoadSTFS()
        {
            contentTitle.Text = xFile.STFS.ContentName;
            gameName.Text = xFile.STFS.TitleName;
            profileID.Text = ByteToString(xFile.STFS.ProfileID);
            deviceID.Text = ByteToString(xFile.STFS.DeviceID);
            consoleID.Text = ByteToString(xFile.STFS.ConsoleID);
            titleID.Text = xFile.STFS.TitleID.ToString("X");
        }

        private string ByteToString(byte[] input)
        {
            string s = "";
            for (int i = 0; i < input.Length; i++)
            {
                string temp = input[i].ToString("X");
                if (temp.Length == 1)
                {
                    s += "0";
                }
                s += temp;
            }
            return s;
        }
    }
}
